﻿using System;
using System.Windows;
using System.Windows.Threading;

//====================================================
// Описание работы классов и методов исходника на:
// https://www.interestprograms.ru
// Исходные коды программ и игр
//====================================================

namespace WpfFigureWindows
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            MyEllipse.Opacity = 0;
            PolyRhombus.Opacity = 0;
            PolyTriangle.Opacity = 0;

            DispatcherTimer timer = new()
            {
                Interval = TimeSpan.FromSeconds(0.03)
            };
            timer.Tick += Timer_Tick;
            timer.Start();
        }


        double counterOpacity = 1;
        int counterElement = 1;
        private void Timer_Tick(object? sender, EventArgs e)
        {
            counterOpacity -= 0.005;

            switch (counterElement)
            {
                case 1:
                    MyEllipse.Opacity = counterOpacity;
                    PolyRhombus.Opacity = 1 - counterOpacity;
                    break;
                case 2:
                    PolyRhombus.Opacity = counterOpacity;
                    PolyTriangle.Opacity = 1 - counterOpacity;
                    break;
                case 3:
                    PolyTriangle.Opacity = counterOpacity;
                    MyEllipse.Opacity = 1 - counterOpacity;
                    break;
            }

            if (counterOpacity <= 0)
            {
                _ = counterElement == 3 ? counterElement = 1 : counterElement++;
                counterOpacity = 1;
            }
        }


        bool _canMove = false;
        Point _offsetPoint = new(0, 0);
        private void Window_MouseDown(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            _canMove = true;

            _offsetPoint = e.MouseDevice.GetPosition(this);


            e.MouseDevice.Capture(this);
        }

        private void Window_MouseMove(object sender, System.Windows.Input.MouseEventArgs e)
        {
            if (_canMove == true)
            {
                Point p = e.MouseDevice.GetPosition(this);
                this.Left = PointToScreen(p).X - _offsetPoint.X;
                this.Top = PointToScreen(p).Y - _offsetPoint.Y;
            }
        }

        private void Window_MouseUp(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            _canMove = false;
            e.MouseDevice.Capture(null);
        }
    }
}
